SystemOrganization addCategory: #ConfigurationOfKEGGeneratorFiniteStateMachines!

Object subclass: #ConfigurationOfKEGGeneratorFiniteStateMachines
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfKEGGeneratorFiniteStateMachines'!

!ConfigurationOfKEGGeneratorFiniteStateMachines commentStamp: '<historical>' prior: 0!
A ConfigurationOfKEGGeneratorFiniteStateMachines is used to load and install the KEGGeneratorFiniteStateMachines related Methods into Pharo 2.0 Smalltalk.  See below for the Smalltalk code lines that you can evaluate in order to load and install the two main code variants.  With tests and withOut tests.

	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.
	
See the web page at http://ss3.gemstone.com/ss/KEGGeneratorFiniteStateMachines.html/Overview.  If that page no longer exists then The main documentation is in the public Methods in the KEGGenerator Class which all have long comments. There are 4 TestCase(s) which you can find in the test runner by looking for the KEGTestCaseObject Class and selecting its subClass KEGGeneratorTest to run the tests. These tests are designed to show lots of examples of how to get the basic functionality of each generator Method to work. They show basic one line examples of each Method but they don`t really give a flavor of how these KEGGenerators are used in practice.  For that we need an example project that uses KEGGenerators to do something.  But we don't have that yet.  It exists in Dolphin Smalltalk but not in Pharo yet.

You can evaluate the following lines of code to load and install various parts of the KEGGeneratorFiniteStateMachines codes.

To install the KEGGeneratorFiniteStateMachines and its supporting Classes and loose Methods evaluate: 
( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load )"<---[ tested ]"
or
( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load: 'default' )"<---[ not tested ]"
or
( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load: 'Core' )"<---[ not tested ]"
or
( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load: 'CompleteWithoutTests' )"<---[ not tested ]"
which should all be equivalent to each other.

To install the KEGGeneratorFiniteStateMachines and its supporting Methods and all the tests of those Methods evaluate:
( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load: 'Tests' )"<---[ tested ]"
or
( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load: 'CompleteWithTests' )"<---[ not tested ]"
which should be equivalent to each other.

There are other ways that you can load the Classes using >>load: but they have a high chance of not working right.  So I would stick to the cases listed above.

Contact me at picoVerse att gMail dott com. There is a google group for this library at https://groups.google.com/forum/?hl=en&fromgroups=#!!forum/keggenerators . KEGGenerators now work with Pharo 2.0 .

Here is the overview from the webpage at :
http://ss3.gemstone.com/ss/KEGGeneratorFiniteStateMachines.html/Overview
in case that webPage no longer exists.

The KEGGeneratorFiniteStateMachines library will help you to implement FiniteStateMachines on top of KEGGenerators.  You do this using the KEGGenerator>>sortInto: Method.  Please see KEGGeneratorTest>>testsortIntoC for lots of simple examples.  Please see the KEGGeneratorScanReplace and KEGGeneratorScanReplaceTest Projects for more complex examples using more than two states( You can probably find these in the ConfigurationBrowser on the WorldMenu on the Pharo Window desktop ).  It seems easy to enhance these FiniteStateMachines with BlockClosures or Objects that respond to >>value: and >>value:value: so that they recognize more complex things with a few states than FSMs can usually recognize.  This is by adding variables and what not to the BlockClosures.  You might even add stacks to them.  To get a context free sort of functionality.  So if you need a simple FSM in just a few lines of code that works on a sequence of Objects then KEGGeneratorFiniteStateMachines is what you need.  If you need a FSM with a lot of states like 20 or more that is very complex then use the KEGFiniteStateMachineV1 Project with the KEGGeneratorParsing Project using the KEGGenerator>>lexUsingFiniteStateMachine: which has been used to lex the BorgLisp LambdaLisp dialect with something like 10 states or more and about 8 transitions per state.  But these may not be ported from Dolphin Smalltalk to Pharo by the time you read this.  If so then contact me to bug me.
KEGGeneratorFiniteStateMachines is a library that implements Smalltalk Generators like those found in the book A Little Smalltalk. It is well documented in the Method comments. The main documentation is in the public Methods in the KEGGenerator Class that all have long comments. There are 4 TestCase(s) which you can find in the test runner by looking for the KEGTestCaseObject Class and selecting its KEGGenerator subClass to run the tests. These tests are designed to show lots of examples of how to get all of the basic functionality of each generator Method to work. They show basic one line examples of each Method but they don`t really give a flavor of how KEGGenerators are used in practice.  Here is how you load the KEGGeneratorFiniteStateMachines Packages into a virgin image. First you right click on the Pharo desktop and then open the Monticello browser. Hit the +Repository button. Select HTTP. Below on this webpage see the Monticello Registration. Click on it and copy the text String. Right click copy. Paste the String into the Monticello dialog. Click OK. A new Repository browser will open. In the left pane click on the ConfigurationOfKEGGeneratorFiniteStateMachines Package .mcz file with the highest version number. It should look something like ConfigurationOfKEGGeneratorFiniteStateMachines-KjellGodo.1.mcz. Click the Load button. It should load. Now open a Workspace and evaluate the following to exclude the testing Packages : ( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load ). To include the testing Packages evaluate the following : ( ( ConfigurationOfKEGGeneratorFiniteStateMachines project version: '1.0' ) load: 'Tests' ) I hope you will give KEGGeneratorFiniteStateMachines a try. Contact me at picoVerse att gMail dott com. There is a google group for this library at https://groups.google.com/forum/?hl=en&fromgroups=#!!forum/keggenerators . KEGGeneratorFiniteStateMachines now work with Pharo 2.0.


!

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'development support' stamp: 'KjellGodo 5/15/2013 20:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'private' stamp: 'KjellGodo 5/15/2013 20:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'private' stamp: 'KjellGodo 5/15/2013 20:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'private' stamp: 'KjellGodo 5/15/2013 20:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'metacello tool support' stamp: 'KjellGodo 5/15/2013 20:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'loading' stamp: 'KjellGodo 5/15/2013 20:10'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'loading' stamp: 'KjellGodo 5/15/2013 20:10'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'loading' stamp: 'KjellGodo 5/15/2013 20:10'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'accessing' stamp: 'KjellGodo 5/15/2013 20:10'!
project

	^self new project! !

!ConfigurationOfKEGGeneratorFiniteStateMachines class methodsFor: 'development support' stamp: 'KjellGodo 5/15/2013 20:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfKEGGeneratorFiniteStateMachines methodsFor: 'as yet unclassified' stamp: 'KjellGodo 5/15/2013 20:14'!
baseline10: spec
	<version: '1.0-baseline'>
	spec for: #common do: [
		spec blessing: #release.
		spec repository: 'http://ss3.gemstone.com/ss/KEGGeneratorFiniteStateMachines'.
		( spec project: 'KEGGeneratorBase' with:[ 
				spec
					className: 'ConfigurationOfKEGGeneratorBase' ;
					versionString: #stable ;
					repository: 'http://ss3.gemstone.com/ss/KEGGenerators' ] )."<-----[ loads the 'default' Group without the tests ]"
		( spec project: 'KEGGeneratorBaseTest' copyFrom: 'KEGGeneratorBase' with:[ spec loads:#( 'Tests' ) ] ).
		spec
			package: 'KEGGeneratorFiniteStateMachines' with: [ spec requires: #( 'KEGGeneratorBase' ) ] ;
			package: 'KEGGeneratorFiniteStateMachinesTest' with: [ spec requires: #( 'KEGGeneratorBaseTest' ) ] ;
			"<-------------------------------------------------------------------------------------------------[  ]"
			package: 'KEGGeneratorFiniteStateMachines' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGGeneratorFiniteStateMachines' ] ;
			package: 'KEGGeneratorFiniteStateMachinesTest' with:[ spec repository: 'http://ss3.gemstone.com/ss/KEGGeneratorFiniteStateMachines' ] .
		spec
			group: 'default' with: #( 'KEGGeneratorFiniteStateMachines' ) ;
			group: 'Core' with: #( 'KEGGeneratorFiniteStateMachines' ) ;
			group: 'Tests' with: #( 'KEGGeneratorFiniteStateMachinesTest' ) ;
			group: 'CompleteWithoutTests' with: #( 'Core' ) ;
			group: 'CompleteWithTests' with: #( 'CompleteWithoutTests' 'Tests' ) ].
		! !

!ConfigurationOfKEGGeneratorFiniteStateMachines methodsFor: 'accessing' stamp: 'KjellGodo 5/15/2013 20:10'!
customProjectAttributes
	 "Edit to return a collection of any custom attributes e.g. for conditional loading: Array with: #'Condition1' with: #'Condition2.
	For more information see: http://code.google.com/p/metacello/wiki/CustomProjectAttrributes"

	^ #().! !

!ConfigurationOfKEGGeneratorFiniteStateMachines methodsFor: 'accessing' stamp: 'KjellGodo 5/15/2013 20:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		project := MetacelloMCProject new projectAttributes: self customProjectAttributes. 
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self project: project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfKEGGeneratorFiniteStateMachines methodsFor: 'as yet unclassified' stamp: 'KjellGodo 5/15/2013 20:16'!
stable: spec 
	<symbolicVersion: #stable>
	
	spec for: #common version: '1.0' .
	
	"Designate the stable version to be version 1.0 for all Smalltalks."! !

!ConfigurationOfKEGGeneratorFiniteStateMachines methodsFor: 'as yet unclassified' stamp: 'KjellGodo 5/15/2013 20:20'!
version10: spec 
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #'release' .
		spec 
			package: 'KEGGeneratorFiniteStateMachines' with: 'KEGGeneratorFiniteStateMachines-KjellGodo.1' ;
			package: 'KEGGeneratorFiniteStateMachinesTest' with: 'KEGGeneratorFiniteStateMachinesTest-KjellGodo.1' ;
			project: 'KEGGeneratorBase' with: '1.0' ;
			project: 'KEGGeneratorBaseTest' with: '1.0' ].

! !
